<?php

/**
 * Time language strings.
 *
 * This content is released under the MIT License (MIT)
 *
 * Copyright (c) 2014-2019 British Columbia Institute of Technology
 * Copyright (c) 2019-2020 CodeIgniter Foundation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 * @package    CodeIgniter
 * @author     Pavel Tajduš - PavelTajdus on Github
 * @copyright  2019-2020 CodeIgniter Foundation
 * @license    https://opensource.org/licenses/MIT	MIT License
 * @link       https://codeigniter.com
 * @since      Version 4.0.0
 * @filesource
 *
 * @codeCoverageIgnore
 */

return [
   'invalidMonth'   => 'Měsíce musí být v rozmezí od 1 do 12. Zadáno: {0}',
   'invalidDay'     => 'Dny musí být v rozmezí od 1 do 31. Zadáno: {0}',
   'invalidOverDay' => 'Dny musí být v rozmezí od 1 do {0}. Zadáno: {1}',
   'invalidHours'   => 'Hodiny musí být v rozmezí od 0 do 23. Zadáno: {0}',
   'invalidMinutes' => 'Minuty mudia byť v rozmedzí od 0 do 59. Zadáno: {0}',
   'invalidSeconds' => 'Vteřiny musí být v rozmezí od 0 do 59. Zadáno: {0}',
   'years'          => '{0, plural, =1{# rok} other{# roky}}',
   'months'         => '{0, plural, =1{# měsíc} other{# měsíce}}',
   'weeks'          => '{0, plural, =1{# tyden} other{# týdny}}',
   'days'           => '{0, plural, =1{# den} other{# dny}}',
   'hours'          => '{0, plural, =1{# hodina} other{# hodiny}}',
   'minutes'        => '{0, plural, =1{# minuta} other{# minuty}}',
   'seconds'        => '{0, plural, =1{# sekunda} other{# vteřiny}}',
   'ago'            => '{0} před',
   'inFuture'       => 'za {0}',
   'yesterday'      => 'Včera',
   'tomorrow'       => 'Zítra',
   'now'            => 'Právě teď',
];
