<?php

/**
 * Time language strings.
 *
 * This content is released under the MIT License (MIT)
 *
 * Copyright (c) 2014-2019 British Columbia Institute of Technology
 * Copyright (c) 2019-2020 CodeIgniter Foundation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 * @package    CodeIgniter
 * @author     CodeIgniter Dev Team
 * @copyright  2019-2020 CodeIgniter Foundation
 * @license    https://opensource.org/licenses/MIT  MIT License
 * @link       https://codeigniter.com
 * @since      Version 4.0.0
 * @filesource
 *
 * @codeCoverageIgnore
 */

return [
   'invalidMonth'   => 'മാസങ്ങൾ 1 നും 12 നും ഇടയിലായിരിക്കണം. നൽകിയിട്ടുള്ളത്: {0}',
   'invalidDay'     => 'ദിവസങ്ങൾ 1 നും 31 നും ഇടയിലായിരിക്കണം. നൽകിയിരിക്കുന്നത്: {0}',
   'invalidOverDay' => 'ദിവസങ്ങൾ 1 നും {0 between നും ഇടയിലായിരിക്കണം. നൽകിയിരിക്കുന്നത്: {1}',
   'invalidHours'   => 'സമയം 0 നും 23 നും ഇടയിലായിരിക്കണം. നൽകിയിരിക്കുന്നത്: {0}',
   'invalidMinutes' => 'മിനിറ്റ് 0 നും 59 നും ഇടയിലായിരിക്കണം. നൽകിയിരിക്കുന്നത്: {0}',
   'invalidSeconds' => 'സെക്കൻഡ് 0 നും 59 നും ഇടയിലായിരിക്കണം. നൽകിയിരിക്കുന്നത്: {0}',
   'years'          => '{0, plural, =1{# year} other{# years}}',
   'months'         => '{0, plural, =1{# month} other{# months}}',
   'weeks'          => '{0, plural, =1{# week} other{# weeks}}',
   'days'           => '{0, plural, =1{# day} other{# days}}',
   'hours'          => '{0, plural, =1{# hour} other{# hours}}',
   'minutes'        => '{0, plural, =1{# minute} other{# minutes}}',
   'seconds'        => '{0, plural, =1{# second} other{# seconds}}',
   'ago'            => '{0} മുമ്പ്',
   'inFuture'       => 'in {0}',
   'yesterday'      => 'ഇന്നലെ',
   'tomorrow'       => 'നാളെ',
   'now'            => 'ഇപ്പോൾ',
];
