<?php

/**
 * Time language strings.
 *
 * This content is released under the MIT License (MIT)
 *
 * Copyright (c) 2014-2019 British Columbia Institute of Technology
 * Copyright (c) 2019-2020 CodeIgniter Foundation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 * @package    CodeIgniter
 * @author     CodeIgniter Dev Team
 * @copyright  2019-2020 CodeIgniter Foundation
 * @license    https://opensource.org/licenses/MIT	MIT License
 * @link       https://codeigniter.com
 * @since      Version 4.0.0
 * @filesource
 *
 * @codeCoverageIgnore
 */

return [
    'invalidMonth'   => 'Maand moet vallen tussen 1 en 12. Opgegeven: {0}',
    'invalidDay'     => 'Dag moet vallen tussen 1 end 31. Opgegeven: {0}',
    'invalidOverDay' => 'Dag moet vallen tussen 1 end {0}. Opgegeven: {1}',
    'invalidHours'   => 'Uur moet vallen tussen 0 end 23. Opgegeven: {0}',
    'invalidMinutes' => 'Minuten moet vallen tussen 0 end 59. Opgegeven: {0}',
    'invalidSeconds' => 'Seconden moet vallen tussen 0 end 59. Opgegeven: {0}',
    'years'          => '{0, plural, =1{# jaar} other{# jaren}}',
    'months'         => '{0, plural, =1{# maand} other{# maanden}}',
    'weeks'          => '{0, plural, =1{# week} other{# weken}}',
    'days'           => '{0, plural, =1{# dag} other{# dagen}}',
    'hours'          => '{0, plural, =1{# uur} other{# uren}}',
    'minutes'        => '{0, plural, =1{# minuut} other{# minuten}}',
    'seconds'        => '{0, plural, =1{# seconde} other{# seconden}}',
    'ago'            => '{0} geleden',
    'inFuture'       => 'binnen {0}',
    'yesterday'      => 'Gisteren',
    'tomorrow'       => 'Morgen',
    'now'            => 'Zonet',
];

