<?php

/**
 * Time language strings.
 *
 * This content is released under the MIT License (MIT)
 *
 * Copyright (c) 2014-2019 British Columbia Institute of Technology
 * Copyright (c) 2019-2020 CodeIgniter Foundation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 * @package    CodeIgniter
 * @author     XuanDung38 (Fox)
 * @copyright  2019-2020 CodeIgniter Foundation
 * @license    https://opensource.org/licenses/MIT	MIT License
 * @link       https://codeigniter.com
 * @since      Version 4.0.0
 * @filesource
 *
 * @codeCoverageIgnore
 */

return [
   'invalidMonth'   => 'Các tháng phải nằm trong khoảng từ 1 đến 12. Đang nhập: {0}',
   'invalidDay'     => 'Ngày phải từ 1 đến 31.  Đang nhập: {0}',
   'invalidOverDay' => 'Ngày phải nằm trong khoảng từ 1 đến {0}.  Đang nhập: {1}',
   'invalidHours'   => 'Giờ phải trong khoảng từ 0 đến 23.  Đang nhập: {0}',
   'invalidMinutes' => 'Phút phải từ 0 đến 59.  Đang nhập: {0}',
   'invalidSeconds' => 'Giây phải trong khoảng từ 0 đến 59.  Đang nhập: {0}',
   'years'          => '{0, plural, =1{# year} khác{# years}}',
   'months'         => '{0, plural, =1{# month} khác{# months}}',
   'weeks'          => '{0, plural, =1{# week} {# weeks}}',
   'days'           => '{0, plural, =1{# day} khác{# days}}',
   'hours'          => '{0, plural, =1{# hour} khác{# hours}}',
   'minutes'        => '{0, plural, =1{# minute} khác{# minutes}}',
   'seconds'        => '{0, plural, =1{# second} khác{# seconds}}',
   'ago'            => '{0} trước',
   'inFuture'       => 'trong {0}',
   'yesterday'      => 'Hôm qua',
   'tomorrow'       => 'Ngày mai',
   'now'            => 'Ngay bây giờ',
];
