<?php

/**
 * Time language strings.
 *
 * This content is released under the MIT License (MIT)
 *
 * Copyright (c) 2014-2019 British Columbia Institute of Technology
 * Copyright (c) 2019-2020 CodeIgniter Foundation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 * @package    CodeIgniter
 * @author     CodeIgniter Dev Team
 * @copyright  2019-2020 CodeIgniter Foundation
 * @license    https://opensource.org/licenses/MIT	MIT License
 * @link       https://codeigniter.com
 * @since      Version 4.0.0
 * @filesource
 *
 * @codeCoverageIgnore
 */

return [
   'invalidMonth'   => '月份必須在 1 到 12 之間。 您所輸入的值: {0}',
   'invalidDay'     => '日期必須在 1 到 31 之間。 您所輸入的值: {0}',
   'invalidOverDay' => '日期必須在 1 到 {0} 之間。 您所輸入的值: {1}',
   'invalidHours'   => '小時必須在 0 到 23 之間。 您所輸入的值: {0}',
   'invalidMinutes' => '分鐘必須在 0 到 59 之間。 您所輸入的值: {0}',
   'invalidSeconds' => '秒數必須在 0 到 59 之間。 您所輸入的值: {0}',
   'years'          => '{0, plural, =1{# year} other{# years}}',
   'months'         => '{0, plural, =1{# month} other{# months}}',
   'weeks'          => '{0, plural, =1{# week} other{# weeks}}',
   'days'           => '{0, plural, =1{# day} other{# days}}',
   'hours'          => '{0, plural, =1{# hour} other{# hours}}',
   'minutes'        => '{0, plural, =1{# minute} other{# minutes}}',
   'seconds'        => '{0, plural, =1{# second} other{# seconds}}',
   'ago'            => '{0} 以前',
   'inFuture'       => '在 {0}',
   'yesterday'      => '昨天',
   'tomorrow'       => '明天',
   'now'            => '當前',
];
